import { setToken, setUserid } from "@/utils/auth";
import { getUrlParam } from "@/utils/util";

if (getUrlParam().token) {
  setUserid(getUrlParam().userid);
  setToken(getUrlParam().token);
}

import Vue from "vue";

import "normalize.css/normalize.css"; // A modern alternative to CSS resets

// import ElementUI from "element-ui";
// import "element-ui/lib/theme-chalk/index.css";
// import locale from 'element-ui/lib/locale/lang/en' // lang i18n

import ElementUI from "@zjlib/element-ui2";
import "@zjlib/element-ui2/lib/theme-chalk/index.css";

window._AMapSecurityConfig = {
  serviceHost: "https://jiasm.zfire.top/" + "_AMapService",
};

import "@zjlib/element-plugins/dest/element-plugins.css";
import ElementPlugins, { AMap } from "@zjlib/element-plugins";
Vue.use(ElementPlugins, {
  // 表单页面表单属性配置
  formAttributes: {
    "label-position": "right",
  },
  // // 操作记录配置
  // operationRecord: function (options) {
  //   // console.log(options.meta.moduleId)
  //   // return new Promise((r, j) => {
  //   //   r([[], []])
  //   // })
  // }
});

Vue.use(AMap);
AMap.initAMapApiLoader({
  // 高德的key
  key: "df9bfabcba60cc6e7ad45ae9923a682d",
  version: "2.0",
  plugins: [
    "AMap.Geocoder",
    "AMap.AutoComplete",
    "AMap.PlaceSearch",
    "AMap.DistrictSearch",
  ],
});

import * as echarts from "echarts";
Vue.prototype.$echarts = echarts;

import "@/styles/index.scss"; // global css

import App from "./App";
import store from "./store";
import router from "./router";

import "@/icons"; // icon
import "@/permission"; // permission control

import * as filters from "./filters"; // global filters

import { successMsg, errorMsg, warningNotify } from "@/utils/common.js";
Vue.prototype.$successMsg = successMsg;
Vue.prototype.$errorMsg = errorMsg;
Vue.prototype.$warningNotify = warningNotify;

Vue.prototype.$imageUrl = process.env.VUE_APP_BASE_API + "/common/img/get?key=";

Vue.prototype.$showImgUrl = function (url) {
  return url;
  try {
    const whiteList = ["https://wework.qpic.cn", "https://thirdwx.qlogo.cn"];
    const { pathname, origin } = new URL(url);
    if (whiteList.includes(origin)) {
      return url;
    }
    if (pathname.startsWith("/")) {
      return `${
        process.env.VUE_APP_BASE_API
      }redirect/img/get?key=${pathname.substring(1)}`;
    }
    return `${process.env.VUE_APP_BASE_API}redirect/img/get?key=${pathname}`;
  } catch (error) {
    return url;
  }
};

import { findElem, deleteEmptyObj } from "@/utils/util.js";
Vue.prototype.$findElem = findElem;
Vue.prototype.$deleteEmptyObj = deleteEmptyObj;

Vue.prototype.$restrict = function (...codes) {
  var roles = this.$route.meta.roles || [];
  for (var code of codes) {
    if (roles.includes(code)) {
      return true;
    }
  }
  return false;
};

/**
 * If you don't want to use mock-server
 * you want to use MockJs for mock api
 * you can execute: mockXHR()
 *
 * Currently MockJs will be used in the production environment,
 * please remove it before going online ! ! !
 */
if (process.env.NODE_ENV === "production") {
  const { mockXHR } = require("../mock");
  mockXHR();
}

// set ElementUI lang to EN
// Vue.use(ElementUI, { locale })
// 如果想要中文版 element-ui，按如下方式声明
Vue.use(ElementUI);

import { Loading } from "element-ui";

var loading;
function startLoading() {
  loading = Loading.service({
    lock: true,
    text: "拼命加载中...",
    spinner: "el-icon-loading",
    customClass: ".app-container",
  });
}

function endLoading() {
  loading.close();
}

Vue.prototype.$startLoading = startLoading;
Vue.prototype.$endLoading = endLoading;

// register global utility filters
Object.keys(filters).forEach((key) => {
  Vue.filter(key, filters[key]);
});

Vue.config.productionTip = false;

new Vue({
  el: "#app",
  router,
  store,
  render: (h) => h(App),
});
